public class ShutdownTaskTest {
 
  private static ExecutorService executorService = Executors
      .newFixedThreadPool(3);
 
  public static void main(String[] args) {
    Runnable mainTask = new Runnable() {
 
      @Override
      public void run() {
        while (executorService.isShutdown() == false) {
          try {
            Runnable task = new Runnable() {
 
              @Override
              public void run() {
                long id = Thread.currentThread().getId();
                try {
                  System.out
                      .printf(
                          "^XNJn܂B: threadId = %d, task = %s\n",
                          id, this);
                  TimeUnit.SECONDS.sleep(5);
                  System.out
                      .printf(
                          "^XNI܂B: threadId = %d, task = %s\n",
                          id, this);
                } catch (InterruptedException e) {
                  System.out
                      .printf(
                          "<<<荞݂܂BthreadId = %d, task = %s>>>\n",
                          id, this);
                }
 
              }
 
            };
            TimeUnit.MILLISECONDS.sleep(500);
            System.out.println("^XÑTu~bgJn܂B");
            executorService.submit(task);
            System.out.println("^XÑTu~bg܂B");
          } catch (RejectedExecutionException e) {
            System.out.println("<<<^XÑTu~bgWFNg܂B>>>");
          } catch (InterruptedException e) {
            System.out.println("荞݂܂B");
          }
        }
        // ŝׂẴ^XNI܂ő҂
        while (executorService.isTerminated() == false) {
          try {
            if (executorService.awaitTermination(1,
                TimeUnit.SECONDS)) {
              break;
            }
            System.out.println("s̃^XN̏I҂Ă܂...");
          } catch (InterruptedException e1) {
            System.out.println("荞݂܂B");
          }
        }
        System.out.println("<<<s̃^XNI܂>>>");
      }
 
    };
    try {
      Thread thread = new Thread(mainTask);
      System.out.println("mainTaskJn܂B");
      thread.start();
      // 5bɃVbg_EB
      TimeUnit.SECONDS.sleep(5);
      System.out.println("<<<Vbg_E̗vJn܂B>>>");
      executorService.shutdownNow();
      System.out.println("<<<Vbg_E̗v܂B>>>");
      thread.join();
      System.out.println("mainTask܂B");
    } catch (InterruptedException e1) {
      System.out.println("荞݂܂B");
    }
 
  }
}