public class CallableTest {
  private static final Logger LOGGER = ...
  // n܂ł̊KvZ郁\bh
  private static BigDecimal fac(long n) {
    BigDecimal result = BigDecimal.ONE;
    for (long i = 1; i <= n; i++) {
      result = result.multiply(BigDecimal.valueOf(i));
    }
    return result;
  }

  // Callable̓͒lƌvZʂi[NX
  private static class Result {
    Long in; // ͒l
    BigDecimal out; // vZ

    Result(final Long in, final BigDecimal out) {
        this.in = in;
        this.out = out;
    }
  }

  public static void main(String[] args) {
    callableTest();
  }

  private static void callableTest() {
    ExecutorService executor = Executors.newFixedThreadPool(3);

    List<Future<Result>> futures = new ArrayList<Future<Result>>();

    for (long i = 2; i <= 1000; i++) {
      final Long n = Long.valueOf(i);
      // Callable̖NX̃CX^X𐶐
      Callable<Result> callable = new Callable<Result>() {
        @Override
        public Result call() {
          BigDecimal fac = fac(n);
          return new Result(n, fac);
        }
      };
      // ^XNTu~bgi˗jFuture擾
      Future<Result> future = executor.submit(callable);
      futures.add(future);
    }
    // futures𑖍Ė߂l擾
    for (Future<Result> future : futures) {
      try {
        // FutureIuWFNg񓯊ɖ߂l擾
        Result result = future.get();
        System.out.printf("fac(%d) = %s\n", result.in,
            result.out);
      } catch (InterruptedException e) {
        LOGGER.error(e);
      } catch (ExecutionException e) {
        LOGGER.error(e);
      }
    }
  }
}