public class BlockingFibGenerator implements Runnable {
 
  public static void main(String[] args)
      throws InterruptedException {
    BlockingFibGenerator task = new BlockingFibGenerator();
    Thread thread = new Thread(task);
    thread.start();
    try {
      TimeUnit.SECONDS.sleep(1);
      int size = task.getFibonaccis().size();
      for (int i = 1; i <= size; i++) {
        BigInteger n = task.getFibonaccis().take();
        System.out.printf("fib = %s\n", n);
      }
    } finally {
      System.out.println("cancel start");
      task.cancel();
      thread.join();
      System.out.println("cancel finish");
    }
  }
 
  private volatile boolean cancelled = false;
 
  private final BlockingQueue<BigInteger> fibonaccis =
      new ArrayBlockingQueue<BigInteger>(2);
 
  private BigInteger fibonacci(BigInteger n) { /* Xg7Ɠ */ }
 
  @Override
  public void run() {
    BigInteger n = BigInteger.ONE;
    try {
      while (cancelled == false) {
        BigInteger f = fibonacci(n);
        fibonaccis.put(f); // L[ςɂȂƃubN
        n = n.add(BigInteger.ONE);
      }
    } catch (InterruptedException e) {
      System.out.println("荞݂܂");
    }
  }
 
  public void cancel() {
    cancelled = true;
  }
 
  public BlockingQueue<BigInteger> getFibonaccis() {
    return fibonaccis;
  }
}